var Class = require('../class/Class.js').Class;

/**
 * @class Event
 * @requires Class
 * 
 * @param {String} type
 * @param {Object} data
 * @param {EventDispatcher} target
  */
var Event = function(){

    /**
     * @property {String} type
     */
    this.type = undefined;

    /**
     * @property {EventDispatcher} target
     */
    this.target = null;

    /**
     * @property {Object} data
     */
    this.data = null;

    /** @ignore */
    this.initialize = function(type, data, target){
        this.type = type;
        this.data = data;
        this.target = target;
    };
};

Event = new Class(new Event());
exports.Event = Event;
