var Class = require("../class/Class.js").Class;

/**
 * @class JsonRpcAbstract
 * @requires Class
 */
var JsonRpcAbstract = function(){
	this._jsonrpc = "2.0";

	this.initialize = function(){

		var args = [].slice.call(arguments, 0);

		if(args.length){
			if(args.length == 1){
				if(args[0] && typeof args[0] == 'string' && args[0].constructor == String){
					try{
						args = this._parse(JSON.parse(args[0]));
					}catch(e){
						throw JsonRpcAbstract.Exceptions.INPROPER_JSON_STRING;
					}
				}else if(args[0] && typeof args[0] == "object" && args[0].constructor == Object){
					try{
						args = this._parse(args[0]);
					}catch(e){
						throw JsonRpcAbstract.Exceptions.INPROPER_JSON;
					}
				}
			}

			this._init(args);
		}
	};

	this._init = function(args){
	};

	this._parse = function(json){
		return [];
	};

	this.toJson = function(){
		return {};
	};

	this.toString = function(){
		return JSON.stringify(this.toJson());
	};
};

JsonRpcAbstract = new Class(new JsonRpcAbstract());

JsonRpcAbstract.Exceptions = {};
JsonRpcAbstract.Exceptions.INPROPER_JSON_STRING = 'Inproper JSON string given';
JsonRpcAbstract.Exceptions.INPROPER_JSON = 'Inproper JSON given';
JsonRpcAbstract.Exceptions.INVALID_JSON_RPC = 'Invalid JSON-RPC given';


exports.JsonRpcAbstract = JsonRpcAbstract;
