var Class = require("../class/Class.js").Class;
var Request = require("./Request.js").Request;
var Response = require("./Response.js").Response;

/**
 * @class RequestProcessor Base class for Request processor family.
 * @param {Request} request
 * @param {Response} response
 */
var RequestProcessor = function(){
    /**
     * Server object
     * @private
     * @type {Server}
     */
    this.server = null;
    /** @ignore */
    this.initialize = function(server){
        this.server = server;        
    };
    /**
     * Main processing method. Should be overloaded.
     */
    this.process = function(request, response){
        
    };
}
RequestProcessor = new Class( new RequestProcessor() );
exports.RequestProcessor = RequestProcessor; 
